<template>
  <div id="app">
    <header-component v-on:logout="logout"></header-component>
    <main v-if="user.name">
      <section>
        <div class="card" v-if="user.role == 'admin'">
          <label>
            List
            <select v-model="list">
              <option value="restaurants">Restaurants</option>
              <option value="users">Users</option>
            </select>
          </label>
        </div>
        <user-card-list v-if="list == 'users'"></user-card-list>
        <restaurant-card-list v-if="list == 'restaurants'"></restaurant-card-list>
        <dynamic-form
        v-if="user.role == 'owner'"
        v-on:success="createRestaurantSuccessful"
        headerText="Create Restaurant"
        buttonText="Create Restaurant"
        endpointUrl="/api/restaurants"
        endpointType="post"
        :fields="[
          {
            name: 'name',
            label: 'Name',
            type: 'text',
            required: true,
          },
        ]">
        </dynamic-form>
      </section>
      <section>
        <div v-if="selectedRestaurant.name && list == 'restaurants'">
          <restaurant-detailed-view></restaurant-detailed-view>
          <dynamic-form
          v-on:success="createReviewSuccessful"
          headerText="Create Review"
          buttonText="Create Review"
          endpointUrl="/api/reviews"
          endpointType="post"
          :requestParam="{
            key: 'restaurant',
            value: selectedRestaurant,
          }"
          :fields="[
            {
              name: 'comment',
              label: 'Comment',
              type: 'textarea',
              required: true,
            },
            {
              name: 'date',
              label: 'Date',
              type: 'date',
              required: true,
            },
            {
              name: 'rating',
              label: 'Rating',
              type: 'dropdown',
              required: true,
              options: [
                {
                  value: 1,
                  label: '1 - Abysmal',
                },
                {
                  value: 2,
                  label: '2 - Meh',
                },
                {
                  value: 3,
                  label: '3 - Alright',
                },
                {
                  value: 4,
                  label: '4 - Splendid',
                },
                {
                  value: 5,
                  label: '5 - Exceptional',
                },
              ],
            },
          ]"
          v-if="(user.role == 'regular' && !userReviewSubmitted())">
          </dynamic-form>
        </div>
      </section>
    </main>
    <div id="login-signup-forms" v-if="!user.name">
      <dynamic-form
      v-on:success="loginSuccessful"
      headerText="Log in"
      buttonText="Log in"
      endpointUrl="/api/users/login"
      endpointType="post"
      :fields="[
        {
          name: 'email',
          label: 'Email',
          type: 'email',
          required: true,
        },
        {
          name: 'password',
          label: 'Password',
          type: 'password',
          required: true,
        },
      ]">
      </dynamic-form>
      <dynamic-form
      v-on:success="signupSuccessful"
      headerText="Sign up"
      buttonText="Sign up"
      endpointUrl="/api/users/register"
      endpointType="post"
      :fields="[
        {
          name: 'name',
          label: 'Name',
          type: 'text',
          required: true,
        },
        {
          name: 'email',
          label: 'Email',
          type: 'email',
          required: true,
        },
        {
          name: 'password',
          label: 'Password',
          type: 'password',
          required: true,
        },
        {
          name: 'password2',
          label: 'Repeat Password',
          type: 'password',
          required: true,
        },
      ]">
      </dynamic-form>
    </div>
  </div>
</template>

<script>
import headerComponent from './components/Header.vue';
import userCardList from './components/UserCardList.vue';
import restaurantCardList from './components/RestaurantCardList.vue';
import restaurantDetailedView from './components/RestaurantDetailedView.vue';
import dynamicForm from './components/DynamicForm.vue';
import store from './store/index';
import { mapState } from 'vuex';
import axios from 'axios';
import { proxy } from './config/proxy';

export default {
  name: 'app',
  computed: {
    ...mapState([
      'user',
      'selectedRestaurant',
    ]),
  },
  data() {
    return {
      // list 'restaurants' or 'users'
      list: 'restaurants',
    };
  },
  components: {
    headerComponent,
    userCardList,
    restaurantCardList,
    restaurantDetailedView,
    dynamicForm,
  },
  methods: {
    userReviewSubmitted() {
      return this.selectedRestaurant.reviews.find((review) => {
        return review.poster == this.user.id;
      });
    },
    createRestaurantSuccessful(response) {
      // add newly created restaurant to list in the frontend
      store.commit('addRestaurantToList', {
        restaurant: response.data,
      });
    },
    createReviewSuccessful(response) {
      // create review successful
      store.commit('createReviewSuccessful', {
        review: response.data,
      });
    },
    logout() {
      // after logging out, revert local state to default values
      this.list = 'restaurants';
    },
    loginSuccessful(response) {
      // log in successful
      store.commit('loginSuccessful', { response });
    },
    signupSuccessful(response) {
      // sign up successful, log in user
      axios.post(proxy + '/api/users/login', JSON.parse(response.config.data)).then((res) => {
        // log in successful
        this.loginSuccessful(res);
      }).catch((error) => {
        // log in failed
        console.log({ error: error.message });
      });
    },
  },
}
</script>

<style lang="scss">
@import url('https://fonts.googleapis.com/css?family=Signika&display=swap');

* {
  margin: 0;
  padding: 0;
  font-family: 'Signika', sans-serif;
}
#app {
  min-height: 100vh;
  background: #abbd74;
  display: flex;
  flex-direction: column;
  main {
    margin-top: 80px;
    section {
      position: relative;
      width: 50%;
      overflow: hidden;
      &:nth-child(2) {
        background: #0002;
        position: fixed;
        right: 0;
        top: 80px;
        height: calc(100% - 80px);
        overflow-y: auto;
      }
    }
  }
}
h3 {
  padding-bottom: 30px;
}
.card {
  position: relative;
  background: white;
  padding: 20px;
  margin: 20px;
  border-radius: 5px;
  overflow: hidden;
  box-shadow: 0 10px 10px #0005;
  &.selected {
    background: #ffecd1;
  }
  label {
    margin-top: 10px;
    display: flex;
    flex-direction: column;
    input {
      width: 100%;
    }
  }
}
.box-shadow {
  box-shadow: 0 10px 10px #0005;
}
.edit-delete-buttons {
  display: flex;
  flex-direction: row;
}
#login-signup-forms {
  z-index: 100;
  display: flex;
  align-items: baseline;
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  .card {
    display: inline-block;
    vertical-align: top;
    width: 300px;
  }
}
</style>
